class GalleryMobile {
    constructor(path, picsAndTitles, container) {
        this.path = path;
        this.picsAndTitles = picsAndTitles;
        // this.titles = titles;
        this.container = container;
    }
    gallery() {
        function isTouchDevice() {
            try {
                document.createEvent("TouchEvent");
                return true;
            } catch (e) {
                return false;
            }
        }
        const cont = this.container;
        const path = this.path;
        const picsAndTitles = this.picsAndTitles;
        let innerHeight = window.innerHeight;
        document.querySelector(cont).style.height = innerHeight + "px";
        const galleryWrap = document.createElement("div");
        galleryWrap.className = "gallery-mobile-wrap";
        document.querySelector(cont).appendChild(galleryWrap);

        const galleryPicWrap = document.createElement("div");
        galleryPicWrap.className = "gallery-mobile-pic-wrap";
        document.querySelector(cont + " .gallery-mobile-wrap").appendChild(galleryPicWrap);

        const startImages = [path + "/" + picsAndTitles[picsAndTitles.length - 1][0], path + "/" + picsAndTitles[0][0], path + "/" + picsAndTitles[1][0]];
        for (let i = 0; i < 3; i++) {
            var galleryPickInner = document.createElement("div");
            galleryPickInner.className = "gallery-mobile-pic-inner";
            document.querySelector(cont + " .gallery-mobile-pic-wrap").appendChild(galleryPickInner);

            var galleryPickInner = document.createElement("div");
            galleryPickInner.className = "gallery-mobile-pic-inside";
            document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[i].appendChild(galleryPickInner);


            var galleryTitle = document.createElement("div");
            galleryTitle.className = "gallery-mobile-pic-title";
            document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[i].appendChild(galleryTitle);
            const startTitles = [picsAndTitles[picsAndTitles.length - 1][1], picsAndTitles[0][1], picsAndTitles[1][1]];

            document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[i].querySelector(".gallery-mobile-pic-title").innerText = startTitles[i];

            var galleryPickPic = document.createElement("img");
            galleryPickPic.className = "gallery-mobile-pic";
            galleryPickPic.src = startImages[i];
            document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[i].querySelector(cont + " .gallery-mobile-pic-inside").appendChild(galleryPickPic);

        }
        for (let i = 0; i < 3; i++) {
            document.querySelectorAll(cont + " .gallery-mobile-pic")[i].ondragstart = function (event) {
                event.preventDefault();
            };
            document.querySelector(cont + " .gallery-mobile-pic-wrap").ondragstart = function (event) {
                event.preventDefault();
            };
        }
        var winWidth = document.querySelector(cont + " .gallery-mobile-wrap").offsetWidth;
        document.querySelector(cont + " .gallery-mobile-pic-wrap").style.left = winWidth * -1 + "px";
        var slideState = false;
        var checkDirection = 1;
        var touchXstate = 0;
        var count = 0;
        var allowedToSwipe = true;
        if (isTouchDevice()) {
            document.querySelector(cont + " .gallery-mobile-wrap").addEventListener("touchstart", (event) => {
                touchXstate = event.touches[0].clientX
                
            });
            document.querySelector(cont + " .gallery-mobile-wrap").addEventListener("touchend", (event) => {
                if (allowedToSwipe) {
                    allowedToSwipe = false;
                    checkDirection = touchXstate - event.changedTouches[0].pageX;
                    if (touchXstate == event.changedTouches[0].pageX) {
                        checkDirection = 1;
                    }
                    pointerEvents();
                    
                }
            });
        } else {
            document.querySelector(cont + " .gallery-mobile-wrap").addEventListener("mouseup", (event) => {
                if (allowedToSwipe) {
                    allowedToSwipe = false;                    
                    checkDirection = touchXstate - event.pageX;
                    if (touchXstate == event.pageX) {
                        checkDirection = 1;
                    }
                    pointerEvents();
                }
            });
            document.querySelector(cont + " .gallery-mobile-wrap").addEventListener("mousedown", (event) => {
                touchXstate = event.pageX;
            });
        }
        function pointerEvents() {
            if (checkDirection > 0)
            {
                count++;
            } else {
                count--;
                if (count < 0) {
                    count = 0;
                    allowedToSwipe =true;
                    return false;
                }
            }
            if (count > picsAndTitles.length - 1) {
                allowedToSwipe = true;
                count = picsAndTitles.length - 1;
                return false;
            }
            if (checkDirection > 0)
            {
                slideState = false;

                document.querySelector(cont + " .gallery-mobile-pic-wrap").style.left = winWidth * -2 + "px";
            } else {

                document.querySelector(cont + " .gallery-mobile-pic-wrap").style.left = "0px";
                slideState = true;
            }
            document.querySelector(cont + " .gallery-mobile-pic-wrap").classList.add("transition");
            setTimeout(function () {
                document.querySelector(cont + " .gallery-mobile-pic-wrap").classList.remove("transition");
                allowedToSwipe = true;
                afterClick();
            }, 500);
        }
        function insert(index1, index2) {
            var newInnerPicWrap = document.createElement("div");
            newInnerPicWrap.className = "gallery-mobile-pic-inner";
            document.querySelector(cont + " .gallery-mobile-pic-wrap").insertBefore(newInnerPicWrap, document.querySelector(cont + " .gallery-mobile-pic-wrap").firstElementChild);

            var newPicInner = document.createElement("div");
            newPicInner.className = "gallery-mobile-pic-inner";

            document.querySelector(cont + " .gallery-mobile-pic-wrap").appendChild(newPicInner);

            for (let i = 0; i < 3; i++) {
                if (i != 1) {
                    var galleryPickInner = document.createElement("div");
                    galleryPickInner.className = "gallery-mobile-pic-inside";
                    document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[i].appendChild(galleryPickInner);

                    var galleryTitle = document.createElement("div");
                    galleryTitle.className = "gallery-mobile-pic-title";
                    document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[i].appendChild(galleryTitle);

                    var galleryPickPic = document.createElement("img");
                    galleryPickPic.className = "gallery-mobile-pic";
                    if (i == 0 && index1 >= 0) {
                        document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[i].querySelector(cont + " .gallery-mobile-pic-inside").appendChild(galleryPickPic);
                    }

                    if (i == 2 && index2 < picsAndTitles.length) {
                        document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[i].querySelector(cont + " .gallery-mobile-pic-inside").appendChild(galleryPickPic);
                    }
                }
            }
            if (index1 >= 0) {
                let insertPath1 = path + "/" + picsAndTitles[index1][0];
                document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[0].querySelector(".gallery-mobile-pic").setAttribute("src", insertPath1);
                document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[0].querySelector(".gallery-mobile-pic-title").innerText = picsAndTitles[index1][1];
            }
            if (index2 < picsAndTitles.length) {
                let insertPath2 = path + "/" + picsAndTitles[index2][0];
                document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[2].querySelector(".gallery-mobile-pic").setAttribute("src", insertPath2);
                document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[2].querySelector(".gallery-mobile-pic-title").innerText = picsAndTitles[index2][1];
            }
            document.querySelector(cont + " .gallery-mobile-pic-wrap").style.left = winWidth * -1 + "px";
        }
        function afterClick() {
            if (!slideState) {
                document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[0].remove();
                document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[0].remove();
                insert(count - 1, count + 1);

            } else {
                document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[1].remove();
                document.querySelectorAll(cont + " .gallery-mobile-pic-inner")[1].remove();
                insert(count - 1, count + 1);
            }
        }
        window.addEventListener("resize", (event) => {
            winWidth = document.querySelector(cont + " .gallery-mobile-wrap").offsetWidth;
            document.querySelector(cont + " .gallery-mobile-pic-wrap").style.left = winWidth * -1 + "px";
            let innerHeight = window.innerHeight;
            document.querySelector(cont).style.height = innerHeight + "px";
        });
    }
}
