class Gallery {
    constructor(path, picsAndTitles, container) {
        this.path = path;
        this.picsAndTitles = picsAndTitles;
        this.container = container;
    }
    gallery() {
        const thumbnailWidth = 110;
        const cont = this.container;
        const path = this.path;
        const picsAndTitles = this.picsAndTitles;


        let innerHeight = window.innerHeight;
        document.querySelector(cont).style.height = innerHeight + "px";

        const galleryWrap = document.createElement("div");
        galleryWrap.className = "gallery-wrap";
        document.querySelector(cont).appendChild(galleryWrap);

        const picWrap = document.createElement("div");
        picWrap.className = "pic-wrap";
        document.querySelector(cont + " .gallery-wrap").appendChild(picWrap);


        const picWrapInner = document.createElement("div");
        picWrapInner.className = "pic-wrap-inner";
        document.querySelector(cont + " .pic-wrap").appendChild(picWrapInner);


        const mainArrowLeft = document.createElement("div");
        mainArrowLeft.className = "main-arow-left";
        document.querySelector(cont + " .pic-wrap-inner").appendChild(mainArrowLeft);

        const mainArrowRight = document.createElement("div");
        mainArrowRight.className = "main-arow-right";
        document.querySelector(cont + " .pic-wrap-inner").appendChild(mainArrowRight);


        const fullPic = document.createElement("img");
        fullPic.src = path + "/" + picsAndTitles[0][0];
        fullPic.className = "full-pic";


        document.querySelector(cont + " .pic-wrap-inner").appendChild(fullPic);
        const picEl = document.querySelector(cont + " .full-pic");

        picEl.onload = function () {    
            calcArrows();
        };
        const thumbPanel = document.createElement("div");
        thumbPanel.className = "thumb-panel";
        document.querySelector(cont + " .gallery-wrap").appendChild(thumbPanel);
        const thumbPanelinner = document.createElement("div");
        thumbPanelinner.className = "thumb-panel-inner";
        document.querySelector(cont + " .thumb-panel").appendChild(thumbPanelinner);

        const titlesInsert = document.createElement("div");
        titlesInsert.className = "titles";
        document.querySelector(cont + " .thumb-panel").appendChild(titlesInsert);
        document.querySelector(cont + " .titles").innerText = picsAndTitles[0][1];

        const thumbPanelInside = document.createElement("div");
        thumbPanelInside.className = "thumb-panel-inside";
        document.querySelector(cont + " .thumb-panel-inner").appendChild(thumbPanelInside);

        for (let i = 0; i < picsAndTitles.length; i++) {

            let thumbsWrap = document.createElement("div");
            thumbsWrap.className = "thumbs-wrap";

            document.querySelector(cont + " .thumb-panel-inside").appendChild(thumbsWrap);
            let thumbs = document.createElement("img");
            thumbs.src = path + "/" + picsAndTitles[i][0];
            thumbs.className = "thumbs";
            document.querySelectorAll(cont + " .thumbs-wrap")[i].appendChild(thumbs);
        }
        for (let i = 0; i < picsAndTitles.length; i++) {
            document.querySelectorAll(cont + " .thumbs")[i].addEventListener("click", function () {
                clickBool = true;
                currentIndex = i;
                if (document.querySelectorAll(cont + " .thumbs-overlay").length > 0)
                {
                    document.querySelector(cont + " .thumbs-overlay").remove();
                }

                const overlay = document.createElement("div");
                overlay.className = "thumbs-overlay";
                document.querySelectorAll(cont + " .thumbs-wrap")[i].appendChild(overlay);

                if (picEl.getAttribute("src") != document.querySelectorAll(cont + " .thumbs")[i].getAttribute("src")) {
                    picEl.classList.add("fade-out-gallery");
                    setTimeout(function () {
                        picEl.classList.remove("fade-out-gallery");
                        let src = document.querySelectorAll(cont + " .thumbs")[i].getAttribute("src");
                        picEl.setAttribute("src", src);
                        picEl.onload = function () {
                            calcArrows();
                        };
                        picEl.classList.add("fade-in-gallery");
                    }, 100);
                    setTimeout(function () {
                        picEl.classList.remove("fade-in-gallery");
                    }, 200);
                }
                document.querySelector(cont + " .titles").innerText = picsAndTitles[i][1];
            });
        }

        var currentIndex = 0;

        var clickBool = true;
        var next;

        document.querySelector(cont + " .main-arow-right").addEventListener("click", function () {
       

            if (clickBool) {
                next = currentIndex;
                if (next > parseInt(picsAndTitles.length) - 1) {
                    next = -1;
                }
                clickBool = false;
            }
            next++;
            if (next > parseInt(picsAndTitles.length) - 1) {
                next = 0;
            }
            onClick();
        });



        picEl.addEventListener("click", function () {

            if (clickBool) {
                next = currentIndex;
                if (next > parseInt(picsAndTitles.length) - 1) {
                    next = -1;
                }
                clickBool = false;
            }
            next++;
            if (next > parseInt(picsAndTitles.length) - 1) {
                next = 0;
            }
            onClick();
        });


        document.querySelector(cont + " .main-arow-left").addEventListener("click", function () {

           

            if (clickBool) {
                next = currentIndex;
                if (next < 0) {
                    next = parseInt(picsAndTitles.length);
                }
                clickBool = false;
            }
            next--;
            if (next < 0) {
                next = parseInt(picsAndTitles.length) - 1;
            }
            onClick();
        });
        let arrowContainer = document.createElement("div");
        arrowContainer.className = "arrow-container";
        document.querySelector(cont + " .thumb-panel").appendChild(arrowContainer);
        let arrowLeft = document.createElement("div");
        arrowLeft.className = "arrow-left";
        document.querySelector(cont + " .arrow-container").appendChild(arrowLeft);
        let arrowRight = document.createElement("div");
        arrowRight.className = "arrow-right";
        document.querySelector(cont + " .arrow-container").appendChild(arrowRight);
        document.querySelector(cont + " .thumb-panel-inside").style.left = 0 + "px";


        let scrollLeft;
        let scrollRight;

        document.querySelector(cont + " .arrow-right").addEventListener("mouseover", function () {
            scrollLeft = setInterval(rightOver, 9);
            let curr;
            let nextCurr;
            function rightOver() {
                if (parseInt(document.querySelector(cont + " .thumb-panel-inside").style.left) - 1 < document.querySelector(cont + " .thumb-panel-inner").offsetWidth - picsAndTitles.length * thumbnailWidth) {
                    return false;
                }
                curr = document.querySelector(cont + " .thumb-panel-inside").style.left;

                nextCurr = parseInt(curr) - 3;
                document.querySelector(cont + " .thumb-panel-inside").style.left = nextCurr + "px";
                if (parseInt(document.querySelector(cont + " .thumb-panel-inside").style.left) < document.querySelector(cont + " .thumb-panel-inner").offsetWidth - picsAndTitles.length * thumbnailWidth) {
                    clearInterval(scrollLeft);
                }
            }

        });
        document.querySelector(cont + " .arrow-right").addEventListener("mouseout", function () {
            clearInterval(scrollLeft);
        });
        document.querySelector(cont + " .arrow-left").addEventListener("mouseover", function () {
            scrollRight = setInterval(leftOver, 9);
            let curr;
            let nextCurr;
            function leftOver() {
                if (parseInt(document.querySelector(cont + " .thumb-panel-inside").style.left) + 1 > 0) {
                    return false;
                }
                curr = document.querySelector(cont + " .thumb-panel-inside").style.left;
                nextCurr = parseInt(curr) + 3;
                document.querySelector(cont + " .thumb-panel-inside").style.left = nextCurr + "px";
                if (parseInt(document.querySelector(cont + " .thumb-panel-inside").style.left) < document.querySelector(cont + " .thumb-panel-inner").offsetWidth - picsAndTitles.length * thumbnailWidth) {
                    clearInterval(scrollRight);
                }
            }

        });

        document.querySelector(cont + " .arrow-left").addEventListener("mouseout", function () {
            clearInterval(scrollRight);
        });
        document.querySelector(cont + " .thumb-panel-inside").style.width = picsAndTitles.length * thumbnailWidth + "px";
        calcResponsive();
        function calcResponsive() {
            if (parseInt(document.querySelector(cont + " .thumb-panel-inside").offsetWidth) < document.querySelector(cont + " .thumb-panel-inner").offsetWidth) {
                document.querySelector(cont + " .arrow-left").style.display = "none";
                document.querySelector(cont + " .arrow-right").style.display = "none";
            } else {
                document.querySelector(cont + " .arrow-left").style.display = "block";
                document.querySelector(cont + " .arrow-right").style.display = "block";
            }
        }

        function onClick() {
            if (document.querySelectorAll(cont + " .thumbs-overlay").length > 0)
            {
                document.querySelector(cont + " .thumbs-overlay").remove();
            }

            const overlay = document.createElement("div");
            overlay.className = "thumbs-overlay ";
            document.querySelectorAll(cont + " .thumbs-wrap")[next].appendChild(overlay);

            picEl.classList.add("fade-out-gallery");
            setTimeout(function () {
                picEl.classList.remove("fade-out-gallery");
                let src = document.querySelectorAll(cont + " .thumbs")[next].getAttribute("src");
                picEl.setAttribute("src", src);
                picEl.onload = function () {
                    calcArrows();
                };
                picEl.classList.add("fade-in-gallery");
            }, 100);
            setTimeout(function () {
                picEl.classList.remove("fade-in-gallery");
            }, 200);
            document.querySelector(cont + " .titles").innerText = picsAndTitles[next][1];
        }

        function calcArrows() {
            var naturalWidth = picEl.naturalWidth;
            var naturalHeight = picEl.naturalHeight;
            var offWidth = parseInt(document.querySelector(cont + " .pic-wrap").offsetWidth);
            var offHeight = parseInt(document.querySelector(cont + " .pic-wrap").offsetHeight);

            var natRatio = naturalWidth / naturalHeight;
            var screenRatio = offWidth / offHeight;

        if (screenRatio > natRatio) {
                document.querySelector(cont + " .pic-wrap-inner").style.width = (offHeight * natRatio + 70) + "px";
            } else {
                document.querySelector(cont + " .pic-wrap-inner").style.width = "100%";
                document.querySelector(cont + " .pic-wrap-inner").style.height = "100%";

            }
            if (naturalHeight < offHeight) {
                document.querySelector(cont + " .pic-wrap-inner").style.maxHeight = naturalHeight + "px";
                document.querySelector(cont + " .pic-wrap-inner").style.maxWidth = naturalWidth + "px";
            } else {
                document.querySelector(cont + " .pic-wrap-inner").style.maxHeight = "100%";
                document.querySelector(cont + " .pic-wrap-inner").style.maxWidth = "100%";
            }
        }
        window.addEventListener("resize", (event) => {
            calcResponsive();
           
            document.querySelector(cont + " .thumb-panel-inside").style.left = 0 + "px";
            let innerHeight = window.innerHeight;
            document.querySelector(cont).style.height = innerHeight + "px";
             calcArrows();
        });
    }
}

